create or replace PROCEDURE CALCULA_ETIQUETA (
        P_NRPLANPROD IN PLANPRODACABADO.NRPLANPROD%TYPE,
        P_CDCENTRAL IN FILIAL.CDFILIAL%TYPE,
        P_NRORG IN NUMBER,
        P_RETORNO OUT VARCHAR2 )
IS 
    V_CONF_A_UTILIZAR INT;
    V_SEQUENCIAL      VARCHAR2(20);
    V_QTCONTAINER     FLOAT;
    V_CDCONTAINER     VARCHAR2(5);
    V_PONTUACAO       NUMBER;
    V_VRQTDEPRATEMB   NUMBER;
    V_NRSEQETIQUETA   NUMBER;
    V_QTAPRODUZIR     FLOAT;
    V_QTCUBA          FLOAT;
    V_QTCUBAADD       FLOAT;
    V_QTEXTRA         FLOAT;
    V_QTRESTOPRODUTO  FLOAT;
    V_CONTADOR        NUMBER;
    V_PROPOSITO       VARCHAR2(1);
PROCEDURE INSERE_LOG(
        P_CDPRODUTO IN VARCHAR2,
        P_NMPRODUTO IN VARCHAR2,
        P_CDFILIAL  IN VARCHAR2,
        P_NMFILIAL  IN VARCHAR2,
        P_CDSERVFILI IN VARCHAR2,
        P_NMSERVICO  IN VARCHAR2,
        P_CDCLIENTE  IN VARCHAR2,
        P_NMRAZSOCCLIE IN VARCHAR2,
        P_CDDESTFILI   IN VARCHAR2,
        P_NMDESTFILI   IN VARCHAR2,
        P_DTCONSUMO    IN DATE,
        P_NRPLANPROD   IN NUMBER,
        P_NRORG        IN NUMBER,
        P_RETORNO     OUT NUMBER)
AS
    V_SEQUENCIAL    VARCHAR2(20);
    V_NRLOGMATPRIMA NUMBER;
BEGIN
    IF (P_NRPLANPROD IS NULL) THEN
        /*Busca novo sequencial para a tabela de log*/
        NOVO_CODIGO_SC('LOGMATPRIMA', V_SEQUENCIAL, 1, P_NRORG);
        V_NRLOGMATPRIMA := TO_NUMBER(V_SEQUENCIAL);
    ELSE
        V_NRLOGMATPRIMA := P_NRPLANPROD;
    END IF;
    BEGIN
         SELECT NRLOGMATPRIMA
           INTO V_NRLOGMATPRIMA
           FROM LOGMATPRIMA
          WHERE NRLOGMATPRIMA = V_NRLOGMATPRIMA
            AND CDPRODUTO = P_CDPRODUTO
            AND CDFILIAL = P_CDFILIAL
            AND CDSERVFILI = P_CDSERVFILI
            AND
            (
                CDCLIENTE = P_CDCLIENTE
                OR P_CDCLIENTE IS NULL
            )
            AND
            (
                CDDESTFILI = P_CDDESTFILI
                OR P_CDDESTFILI IS NULL
            )
            AND DTCARDAPIO = P_DTCONSUMO
            AND NRORG = P_NRORG;
    EXCEPTION
    WHEN NO_DATA_FOUND THEN
         INSERT
           INTO LOGMATPRIMA
            (
                NRLOGMATPRIMA, CDPRODUTO, NMPRODUTO, DSORIGEM, CDFILIAL, NMFILIAL,
                CDSERVFILI, NMSERVICO, CDCLIENTE, NMRAZSOCCLIE, CDDESTFILI, NMDESTFILI,
                DTCARDAPIO, NRORG
            )
            VALUES
            (
                V_NRLOGMATPRIMA, P_CDPRODUTO, P_NMPRODUTO, 'CALCULAEMBALAGEM', P_CDFILIAL, P_NMFILIAL,
                P_CDSERVFILI, P_NMSERVICO, P_CDCLIENTE, P_NMRAZSOCCLIE, P_CDDESTFILI, P_NMDESTFILI,
                P_DTCONSUMO, P_NRORG
            );
    END;
    P_RETORNO := V_NRLOGMATPRIMA;
END;
BEGIN
     SELECT DECODE(P.IDPESAPAETIQ, 'N', 'N', 'C')
       INTO V_PROPOSITO
       FROM PARAMPLANEJA P
      WHERE P.NRORG = P_NRORG
        AND P.CDFILIAL = P_CDCENTRAL;
        
    IF V_PROPOSITO = 'C' THEN
         DELETE
           FROM ETIQUETACOZ
          WHERE NRPLANPROD = P_NRPLANPROD;
          
        FOR C_CARD IN
        ( SELECT DISTINCT CC.CDFILIAL, CC.CDSERVFILI, CC.DTCONSUMO, CC.CDCLIENTE, CC.CDDESTFILI, PP.CDPRODACABADO
           FROM CARDACLIPLANPROD CC
        INNER JOIN PLANPRODFILIAGREGA PP
             ON PP.NRPLANPROD = CC.NRPLANPROD
            AND PP.CDPRODACABADO = CC.CDPRODUTO
            AND PP.CDFILIAGREG = CC.CDFILIAL
            AND PP.CDSERVFILIAGREG = CC.CDSERVFILI
            AND PP.IDPRODUZIR = 'S'
            AND PP.IDESTADO <> 'PRODUCAO'
          WHERE CC.NRPLANPROD = P_NRPLANPROD
       ORDER BY CC.CDFILIAL, CC.CDSERVFILI, CC.DTCONSUMO, CC.CDCLIENTE, CC.CDDESTFILI
        )
        LOOP
            BEGIN
                 SELECT MAX(CONF_A_UTILIZAR) INTO V_CONF_A_UTILIZAR
                   FROM (SELECT 1 AS CONF_A_UTILIZAR
                           FROM DUAL
                          WHERE EXISTS (SELECT 1
                                          FROM CNFDISTEMBSERV
                                         WHERE CDFILIAL = C_CARD.CDFILIAL
                                           AND CDSERVFILI = C_CARD.CDSERVFILI
                                           AND CDCLIENTE IS NULL)
                          UNION
                         SELECT 2 AS CONF_A_UTILIZAR
                           FROM DUAL
                          WHERE EXISTS (SELECT 1
                                          FROM CNFDISTEMBSERV
                                         WHERE CDFILIAL = C_CARD.CDFILIAL
                                           AND CDSERVFILI = C_CARD.CDSERVFILI
                                           AND CDCLIENTE = C_CARD.CDCLIENTE
                                           AND CDDESTFILI = C_CARD.CDDESTFILI)
                        ) S;
            EXCEPTION
                WHEN NO_DATA_FOUND THEN
                    V_CONF_A_UTILIZAR := 0;
            END;
            
            FOR C_PRATOS IN
                (SELECT CP.NRSEQPRATCAR, CP.NRCARDACLIPLANPROD, CP.CDFILAUXPRAT, CP.CDPRATO, P.NMPRATO, CP.QTCOMESTICLI,
                        CP.QTAPRODUZIR, NVL(CP.QTEXTRA, 0) AS QTEXTRA, CNF.NRGRUPO, CNF.CDCNFDISTEMBSERV, CNF.IDPROPOSITO, CNF.CDCONTAINER,
                        R.VRQTDEPRATEMB, CP.CDPRODUTO
                   FROM CARDACLIPLANPROD CP
                   LEFT JOIN (SELECT CNF.NRSEQCNFMES AS NRSEQCNFCARD, CNF.NRGRUPOEMB AS NRGRUPO, CNF.CDCONTAINER AS CDCNFDISTEMBSERV, CNF.CDCONTAINER, C.IDPROPOSITO
                               FROM CNFCAMES CNF
                               LEFT JOIN CONTAINER C ON C.CDCONTAINER = CNF.CDCONTAINER
                                                    AND C.IDPROPOSITO = 'C'
                              WHERE CDFILIAL = C_CARD.CDFILIAL
                                AND CDSERVFILI = C_CARD.CDSERVFILI
                                AND DTREFECNFMES = (C_CARD.DTCONSUMO - TO_CHAR(C_CARD.DTCONSUMO, 'DD')+ 1)
                                AND ( V_CONF_A_UTILIZAR = 1 OR V_CONF_A_UTILIZAR = 0 )
                              UNION ALL
                             SELECT CNF.NRSEQCNFCARD, CNF.NRGRUPO, CNF.CDCNFDISTEMBSERV, CNF.CDCONTAINER, C.IDPROPOSITO
                               FROM CNFDISTEMBSERV CNF
                               LEFT JOIN CONTAINER C ON C.CDCONTAINER = CNF.CDCONTAINER
                                                    AND C.IDPROPOSITO = 'C'
                              WHERE CDFILIAL = C_CARD.CDFILIAL
                                AND CDSERVFILI = C_CARD.CDSERVFILI
                                AND CDCLIENTE = C_CARD.CDCLIENTE
                                AND CDDESTFILI = C_CARD.CDDESTFILI
                                AND V_CONF_A_UTILIZAR = 2
                             ) CNF ON CNF.NRSEQCNFCARD = CP.NRSEQPRATCAR
                   LEFT JOIN RELPRATEMB R ON R.CDFILAUXPRAT = CP.CDFILAUXPRAT
                                         AND R.CDPRATO = CP.CDPRATO
                                         AND R.CDCONTAINER = CNF.CDCONTAINER
                  INNER JOIN PRATO P ON P.CDFILAUXPRAT = CP.CDFILAUXPRAT
                                    AND P.CDPRATO = CP.CDPRATO
                  INNER JOIN PLANPRODFILIAGREGA PP ON PP.NRPLANPROD = CP.NRPLANPROD
                                                  AND PP.NRPLANPROD = CP.NRPLANPROD
                                                  AND PP.CDPRODACABADO = CP.CDPRODUTO
                                                  AND PP.CDFILIAGREG = CP.CDFILIAL
                                                  AND PP.CDSERVFILIAGREG = CP.CDSERVFILI
                                                  AND PP.DTCONSUMO = CP.DTCONSUMO
                                                  AND PP.IDPRODUZIR = 'S'
                                                  AND PP.IDESTADO <> 'PRODUCAO'
                  WHERE CP.NRPLANPROD = P_NRPLANPROD
                    AND CP.DTCONSUMO = C_CARD.DTCONSUMO
                    AND CP.CDPRODUTO = C_CARD.CDPRODACABADO
                    AND C_CARD.CDFILIAL = CP.CDFILIAL
                    AND C_CARD.CDSERVFILI = CP.CDSERVFILI
                    AND (CP.CDCLIENTE = C_CARD.CDCLIENTE OR C_CARD.CDCLIENTE IS NULL)
                    AND (CP.CDDESTFILI = C_CARD.CDDESTFILI OR C_CARD.CDDESTFILI IS NULL)
               ORDER BY CNF.NRGRUPO
                )
            LOOP
                IF (C_PRATOS.IDPROPOSITO = 'C') AND (C_PRATOS.VRQTDEPRATEMB IS NOT NULL) THEN
                    V_QTCUBA := C_PRATOS.QTAPRODUZIR + C_PRATOS.QTEXTRA;
                    V_QTCONTAINER := TRUNC(V_QTCUBA/C_PRATOS.VRQTDEPRATEMB);
                    IF MOD(V_QTCUBA, C_PRATOS.VRQTDEPRATEMB) <> 0 THEN
                        V_QTCONTAINER := V_QTCONTAINER + 1;
                    END IF;
                    
                    WHILE V_QTCONTAINER > 0
                    LOOP
                        NOVO_CODIGO_SC('ETIQUETACOZ',V_SEQUENCIAL);
                        V_NRSEQETIQUETA := TO_NUMBER(V_SEQUENCIAL);
                        IF V_QTCUBA > C_PRATOS.VRQTDEPRATEMB THEN
                            V_QTCUBAADD := C_PRATOS.VRQTDEPRATEMB;
                            V_QTCUBA := V_QTCUBA - C_PRATOS.VRQTDEPRATEMB;
                        ELSE
                            V_QTCUBAADD := V_QTCUBA;
                        END IF;
                    
                        INSERT INTO ETIQUETACOZ ( NRETIQUETACOZ, NRPLANPROD, 
                            NRCARDACLIPLANPROD, CDCONTAINER, QTREAL, IDATIVO,
                            NRORG, IDIMPRESSO)
                        VALUES ( V_NRSEQETIQUETA, P_NRPLANPROD, 
                            C_PRATOS.NRCARDACLIPLANPROD, C_PRATOS.CDCONTAINER, V_QTCUBAADD, 'S',
                            P_NRORG, 'N'
                        );
                        
                        V_QTCONTAINER := V_QTCONTAINER - 1;
                    END LOOP;
                ELSE
                    IF (C_PRATOS.CDCNFDISTEMBSERV = 'DISTR') THEN
                        V_QTAPRODUZIR := C_PRATOS.QTAPRODUZIR;
                        V_QTEXTRA := C_PRATOS.QTEXTRA;
                        V_QTRESTOPRODUTO := 1;
                        V_CONTADOR := 1;
                        
                        WHILE V_QTRESTOPRODUTO > 0
                        LOOP
									BEGIN
									 SELECT A.CDCONTAINER, A.VRQTDEPRATEMB, A.QTRESTANTE
										INTO V_CDCONTAINER, V_VRQTDEPRATEMB, V_QTAPRODUZIR
									   FROM
										(SELECT R.CDCONTAINER, R.VRQTDEPRATEMB, (V_QTAPRODUZIR + V_QTEXTRA) - R.VRQTDEPRATEMB AS QTRESTANTE
										   FROM RELPRATEMB R
										  WHERE R.CDPRATO = C_PRATOS.CDPRATO
											AND R.CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
											AND R.VRQTDEPRATEMB <= (V_QTAPRODUZIR + V_QTEXTRA)
											AND NOT EXISTS (SELECT ER.CDCONTAINER 
															  FROM EXCECRELPRATEMBFIL ER
															 WHERE ER.CDFILIAL = C_CARD.CDFILIAL
															   AND ER.CDPRATO = R.CDPRATO
															   AND ER.CDFILAUXPRAT = R.CDFILAUXPRAT)
										 UNION ALL
										SELECT ER.CDCONTAINER, ER.VRQTDEPRATEMB, (V_QTAPRODUZIR + V_QTEXTRA) - ER.VRQTDEPRATEMB AS QTRESTANTE 
										  FROM EXCECRELPRATEMBFIL ER
										 WHERE ER.CDFILIAL = C_CARD.CDFILIAL
										   AND ER.CDPRATO = C_PRATOS.CDPRATO
										   AND ER.CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
										   AND ER.VRQTDEPRATEMB <= (V_QTAPRODUZIR + V_QTEXTRA)
										) A
									INNER JOIN CONTAINER C
										 ON A.CDCONTAINER = C.CDCONTAINER
										AND C.IDPROPOSITO = 'C'
									  WHERE ROWNUM = 1
									  ORDER BY A.VRQTDEPRATEMB DESC;
								EXCEPTION
									WHEN NO_DATA_FOUND THEN
										IF V_CONTADOR = 1 THEN
											INSERE_LOG (C_PRATOS.CDPRODUTO, '', C_CARD.CDFILIAL, '', 
												C_CARD.CDSERVFILI, '', C_CARD.CDCLIENTE, '', 
												C_CARD.CDDESTFILI, '', C_CARD.DTCONSUMO, 
												P_RETORNO, P_NRORG, P_RETORNO);

											ELSE
												SELECT A.CDCONTAINER, A.VRQTDEPRATEMB
												   INTO V_CDCONTAINER, V_VRQTDEPRATEMB
												   FROM
													(SELECT R.CDCONTAINER, R.VRQTDEPRATEMB
													   FROM RELPRATEMB R
													  WHERE R.CDPRATO = C_PRATOS.CDPRATO
														AND R.CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
														AND R.VRQTDEPRATEMB >= (V_QTAPRODUZIR + V_QTEXTRA)
														AND NOT EXISTS (SELECT ER.CDCONTAINER 
																		  FROM EXCECRELPRATEMBFIL ER
																		 WHERE ER.CDFILIAL = C_CARD.CDFILIAL
																		   AND ER.CDPRATO = R.CDPRATO
																		   AND ER.CDFILAUXPRAT = R.CDFILAUXPRAT)
													 UNION ALL
													SELECT ER.CDCONTAINER, ER.VRQTDEPRATEMB
													  FROM EXCECRELPRATEMBFIL ER
													 WHERE ER.CDFILIAL = C_CARD.CDFILIAL
													   AND ER.CDPRATO = C_PRATOS.CDPRATO
													   AND ER.CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
													   AND ER.VRQTDEPRATEMB >= (V_QTAPRODUZIR + V_QTEXTRA)
													) A
												INNER JOIN CONTAINER C
													 ON A.CDCONTAINER = C.CDCONTAINER
													AND C.IDPROPOSITO = 'C'
												  WHERE ROWNUM = 1
												  ORDER BY A.VRQTDEPRATEMB ASC;

												  NOVO_CODIGO_SC('ETIQUETACOZ',V_SEQUENCIAL);
												  V_NRSEQETIQUETA := TO_NUMBER(V_SEQUENCIAL);

												INSERT INTO ETIQUETACOZ ( NRETIQUETACOZ, NRPLANPROD, 
													NRCARDACLIPLANPROD, CDCONTAINER, QTREAL, IDATIVO,
													NRORG, IDIMPRESSO
												) VALUES ( V_NRSEQETIQUETA, P_NRPLANPROD,
													C_PRATOS.NRCARDACLIPLANPROD, V_CDCONTAINER, V_QTRESTOPRODUTO, 'S',
													P_NRORG, 'N' );
										END IF;
		
										V_VRQTDEPRATEMB := NULL;
										V_QTRESTOPRODUTO := 0;
										V_CONTADOR := 0;
								END;
                            -- END;

                            IF (V_VRQTDEPRATEMB IS NOT NULL) THEN
                                NOVO_CODIGO_SC('ETIQUETACOZ',V_SEQUENCIAL);
                                V_NRSEQETIQUETA := TO_NUMBER(V_SEQUENCIAL);
								
								IF (V_QTAPRODUZIR < 0) THEN
									V_VRQTDEPRATEMB := V_QTAPRODUZIR + V_VRQTDEPRATEMB;
								END IF;

                                INSERT INTO ETIQUETACOZ ( NRETIQUETACOZ, NRPLANPROD, 
                                    NRCARDACLIPLANPROD, CDCONTAINER, QTREAL, IDATIVO,
                                    NRORG, IDIMPRESSO
                                ) VALUES ( V_NRSEQETIQUETA, P_NRPLANPROD, 
                                    C_PRATOS.NRCARDACLIPLANPROD, V_CDCONTAINER, V_VRQTDEPRATEMB, 'S',
                                    P_NRORG, 'N' );
                                    
                                V_QTEXTRA := 0;
                                V_QTRESTOPRODUTO := V_QTAPRODUZIR;
                                V_CONTADOR := 0;
                            END IF;
                        END LOOP;
                    ELSE
                        IF (C_PRATOS.CDCNFDISTEMBSERV = 'DIST') THEN
                            BEGIN
                                 SELECT CDCONTAINER, VRQTDEPRATEMB, PONTUACAO
                                    INTO V_CDCONTAINER, V_VRQTDEPRATEMB, V_PONTUACAO
                                   FROM
                                    (SELECT A.CDCONTAINER, VRQTDEPRATEMB, MAX(A.QTEMBCOMPLETAS + A.QTNAOAPROVEITAMENTO) AS PONTUACAO
                                       FROM 
                                        ( SELECT EMB.CDCONTAINER, CASE TRUNC(C_PRATOS.QTAPRODUZIR + C_PRATOS.QTEXTRA / EMB.VRQTDEPRATEMB)
												 	WHEN 0
													THEN 1
													ELSE TRUNC(C_PRATOS.QTAPRODUZIR + C_PRATOS.QTEXTRA / EMB.VRQTDEPRATEMB)
												 END AS QTEMBCOMPLETAS, EMB.VRQTDEPRATEMB,
												 CASE MOD(C_PRATOS.QTAPRODUZIR + C_PRATOS.QTEXTRA , EMB.VRQTDEPRATEMB)
													WHEN 0
													THEN 0
													ELSE (1 - ((EMB.VRQTDEPRATEMB - MOD(C_PRATOS.QTAPRODUZIR + C_PRATOS.QTEXTRA , EMB.VRQTDEPRATEMB)) / EMB.VRQTDEPRATEMB))
												 END AS QTNAOAPROVEITAMENTO
										    FROM (SELECT R.CDCONTAINER, R.VRQTDEPRATEMB
												   FROM RELPRATEMB R
												  WHERE R.CDPRATO = C_PRATOS.CDPRATO
													AND R.CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
													AND NOT EXISTS (SELECT ER.CDCONTAINER 
																	  FROM EXCECRELPRATEMBFIL ER
																	 WHERE ER.CDFILIAL = C_CARD.CDFILIAL
																	   AND ER.CDPRATO = R.CDPRATO
																	   AND ER.CDFILAUXPRAT = R.CDFILAUXPRAT)												
													 UNION ALL
													SELECT ER.CDCONTAINER, ER.VRQTDEPRATEMB
													  FROM EXCECRELPRATEMBFIL ER
													 WHERE ER.CDFILIAL = C_CARD.CDFILIAL
													   AND ER.CDPRATO = C_PRATOS.CDPRATO
													   AND ER.CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
												) EMB
											INNER JOIN CONTAINER C
											   ON EMB.CDCONTAINER = C.CDCONTAINER
											  AND C.IDPROPOSITO = 'C'
											) A
									   GROUP BY CDCONTAINER, VRQTDEPRATEMB
									   ORDER BY PONTUACAO DESC 
										)
									  WHERE ROWNUM = 1;
                            EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                                V_VRQTDEPRATEMB := NULL;
                            END;
                                    
                                    V_QTAPRODUZIR := C_PRATOS.QTAPRODUZIR; 
                            
                            IF (V_VRQTDEPRATEMB IS NOT NULL) THEN
                                V_QTCONTAINER := TRUNC(C_PRATOS.QTAPRODUZIR/V_VRQTDEPRATEMB);
                                
                                IF MOD(C_PRATOS.QTAPRODUZIR, V_VRQTDEPRATEMB) <> 0 THEN
                                    V_QTCONTAINER := V_QTCONTAINER + 1;
                                END IF;
                                
                                WHILE V_QTCONTAINER > 0
                                LOOP
                                    NOVO_CODIGO_SC('ETIQUETACOZ',V_SEQUENCIAL);
                                    V_NRSEQETIQUETA := TO_NUMBER(V_SEQUENCIAL);
                                
                                    IF (V_VRQTDEPRATEMB > V_QTAPRODUZIR) THEN
                                        V_QTRESTOPRODUTO := V_QTAPRODUZIR;
                                    ELSE
                                        V_QTRESTOPRODUTO := V_VRQTDEPRATEMB;
                                    END IF;
                                    
                                    
                                     INSERT INTO ETIQUETACOZ ( NRETIQUETACOZ, NRPLANPROD, 
                                        NRCARDACLIPLANPROD, CDCONTAINER, QTREAL, IDATIVO,
                                        NRORG, IDIMPRESSO
                                    ) VALUES (V_NRSEQETIQUETA, P_NRPLANPROD, 
                                        C_PRATOS.NRCARDACLIPLANPROD, V_CDCONTAINER, V_QTRESTOPRODUTO, 'S',
                                        P_NRORG, 'N'
                                    );
                                    
                                    V_QTCONTAINER := V_QTCONTAINER - 1;                                    
                                    V_QTAPRODUZIR := V_QTAPRODUZIR - V_QTRESTOPRODUTO; 
                                END LOOP;
                                
                            END IF;
                        ELSE
                            INSERE_LOG (C_PRATOS.CDPRODUTO, '', C_CARD.CDFILIAL, '', 
                                        C_CARD.CDSERVFILI, '', C_CARD.CDCLIENTE, '', 
                                        C_CARD.CDDESTFILI, '', C_CARD.DTCONSUMO, 
                                        P_RETORNO, P_NRORG, P_RETORNO);
                        END IF;
                    END IF;
                END IF;
            END LOOP;
        END LOOP;
        
        FOR C_ANTECIPACAO IN (
            SELECT PP.CDFILIAGREG, PP.CDSERVFILIAGREG, PP.CDPRODACABADO, PA.CDPRATO, 
                   PA.CDFILAUXPRAT, PP.DTCONSUMO, PA.QTAPRODUZIR, PA.QTEXTRA
            FROM PLANPRODFILIAGREGA PP
            INNER JOIN PLANPRODACABADO PA ON 
                PA.NRPLANPROD = PP.NRPLANPROD
                AND PA.CDPRODACABADO = PP.CDPRODACABADO
                AND PP.IDESTADO = 'PRODUCAO'
            WHERE PP.NRPLANPROD = P_NRPLANPROD
            ORDER BY PP.CDFILIAGREG, PP.CDSERVFILIAGREG, PP.DTCONSUMO 
        )LOOP
            V_QTAPRODUZIR := C_ANTECIPACAO.QTAPRODUZIR;
            V_QTEXTRA := C_ANTECIPACAO.QTEXTRA;
            V_QTRESTOPRODUTO := 1;
            V_CONTADOR := 1;
            
            WHILE V_QTRESTOPRODUTO > 0
            LOOP
                BEGIN
                     SELECT CDCONTAINER, VRQTDEPRATEMB, QTRESTANTE
                       INTO V_CDCONTAINER, V_VRQTDEPRATEMB, V_QTAPRODUZIR
                       FROM
                        (SELECT R.CDCONTAINER, R.VRQTDEPRATEMB, (V_QTAPRODUZIR + V_QTEXTRA) - VRQTDEPRATEMB AS QTRESTANTE
                           FROM RELPRATEMB R
                        INNER JOIN CONTAINER C
                             ON R.CDCONTAINER = C.CDCONTAINER
                            AND C.IDPROPOSITO = 'C'
                          WHERE CDPRATO = C_ANTECIPACAO.CDPRATO
                            AND CDFILAUXPRAT = C_ANTECIPACAO.CDFILAUXPRAT
                            AND VRQTDEPRATEMB <= (V_QTAPRODUZIR + V_QTEXTRA)
                       ORDER BY VRQTDEPRATEMB DESC
                        ) A
                      WHERE ROWNUM = 1;
                EXCEPTION
                WHEN NO_DATA_FOUND THEN
                    IF V_CONTADOR = 1 THEN
                        INSERE_LOG (C_ANTECIPACAO.CDPRODACABADO, '', C_ANTECIPACAO.CDFILIAGREG, '', 
                            C_ANTECIPACAO.CDSERVFILIAGREG, '', '', '', 
                            '', '', C_ANTECIPACAO.DTCONSUMO, 
                            P_RETORNO, P_NRORG, P_RETORNO);
                            
                        ELSE
                            SELECT CDCONTAINER, VRQTDEPRATEMB
                               INTO V_CDCONTAINER, V_VRQTDEPRATEMB
                               FROM
                                (SELECT R.CDCONTAINER, R.VRQTDEPRATEMB
                                   FROM RELPRATEMB R
                                INNER JOIN CONTAINER C
                                     ON R.CDCONTAINER = C.CDCONTAINER
                                    AND C.IDPROPOSITO = 'C'
                                  WHERE CDPRATO = C_ANTECIPACAO.CDPRATO
                                    AND CDFILAUXPRAT = C_ANTECIPACAO.CDFILAUXPRAT
                                    AND VRQTDEPRATEMB >= (V_QTAPRODUZIR + V_QTEXTRA)
                               ORDER BY VRQTDEPRATEMB ASC
                                ) A
                              WHERE ROWNUM = 1;
                              
                              NOVO_CODIGO_SC('ETIQUETACOZ',V_SEQUENCIAL);
                              V_NRSEQETIQUETA := TO_NUMBER(V_SEQUENCIAL);
                              
                              INSERT INTO ETIQUETACOZ ( NRETIQUETACOZ, NRPLANPROD, 
                                CDPRODUTO, CDCONTAINER, QTREAL, IDATIVO,
                                NRORG, IDIMPRESSO
                            ) VALUES ( V_NRSEQETIQUETA, P_NRPLANPROD, 
                                C_ANTECIPACAO.CDPRODACABADO, V_CDCONTAINER, V_QTRESTOPRODUTO, 'S',
                                P_NRORG, 'N' );
                    END IF;
                    
                    V_VRQTDEPRATEMB := NULL;
                    V_QTRESTOPRODUTO := 0;
                    V_CONTADOR := 0;
                    
                END;
                IF (V_VRQTDEPRATEMB IS NOT NULL) THEN
                    NOVO_CODIGO_SC('ETIQUETACOZ',V_SEQUENCIAL);
                    V_NRSEQETIQUETA := TO_NUMBER(V_SEQUENCIAL);
                    
                    INSERT INTO ETIQUETACOZ ( NRETIQUETACOZ, NRPLANPROD, 
                        CDPRODUTO, CDCONTAINER, QTREAL, IDATIVO,
                        NRORG, IDIMPRESSO
                    ) VALUES ( V_NRSEQETIQUETA, P_NRPLANPROD, 
                        C_ANTECIPACAO.CDPRODACABADO, V_CDCONTAINER, V_VRQTDEPRATEMB, 'S',
                        P_NRORG, 'N' );
                        
                    V_QTEXTRA := 0;
                    V_QTRESTOPRODUTO := V_QTAPRODUZIR;
                    V_CONTADOR := 0;
                END IF;    
            END LOOP;
        END LOOP;
    END IF;
    
    IF P_RETORNO IS NULL THEN
        P_RETORNO := 'S';
    END IF;
END;
/
